/*
*  Copyright 2019-2020 Zheng Jie
*
*  Licensed under the Apache License, Version 2.0 (the "License");
*  you may not use this file except in compliance with the License.
*  You may obtain a copy of the License at
*
*  http://www.apache.org/licenses/LICENSE-2.0
*
*  Unless required by applicable law or agreed to in writing, software
*  distributed under the License is distributed on an "AS IS" BASIS,
*  WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
*  See the License for the specific language governing permissions and
*  limitations under the License.
*/
package me.zhengjie.modules.dm.camera.repository;

import me.zhengjie.modules.dm.camera.domain.DmCamera;
import org.springframework.data.jpa.repository.JpaRepository;
import org.springframework.data.jpa.repository.JpaSpecificationExecutor;
import org.springframework.data.jpa.repository.Query;
import org.springframework.data.repository.query.Param;

/**
* @website https://el-admin.vip
* @author xwx
* @date 2021-04-20
**/
public interface DmCameraRepository extends JpaRepository<DmCamera, Long>, JpaSpecificationExecutor<DmCamera> {

    @Query(value = "select count(*) from dm_camera where code =:code and if( :id is not null ,id= :id,1=1)",nativeQuery = true)
    int checkCode(@Param("code") String code, @Param("id") Long id);
}