/*
*  Copyright 2019-2020 Zheng Jie
*
*  Licensed under the Apache License, Version 2.0 (the "License");
*  you may not use this file except in compliance with the License.
*  You may obtain a copy of the License at
*
*  http://www.apache.org/licenses/LICENSE-2.0
*
*  Unless required by applicable law or agreed to in writing, software
*  distributed under the License is distributed on an "AS IS" BASIS,
*  WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
*  See the License for the specific language governing permissions and
*  limitations under the License.
*/
package me.zhengjie.modules.dm.foodPj.service.dto;

import lombok.Data;
import java.sql.Timestamp;
import java.io.Serializable;
import com.alibaba.fastjson.annotation.JSONField;
import com.alibaba.fastjson.serializer.ToStringSerializer;
import me.zhengjie.modules.dm.foodCate.domain.DmFoodCate;
import me.zhengjie.modules.dm.user.domain.DmUser;

/**
* @website https://el-admin.vip
* @description /
* @author sunmz
* @date 2021-09-15
**/
@Data
public class DmFoodPjDto implements Serializable {

    /** 防止精度丢失 */
    @JSONField(serializeUsing = ToStringSerializer.class)
    private Long id;

    private Long oid;

    private String cateName;

    /** 菜品名称 */
    private String foodName;

    /** 菜品编号 */
    private String foodCode;

    /** 菜品分类 */
    private DmFoodCate foodType;

    /** 用户工号 */
    private DmUser userCode;

    /** 用户姓名 */
    private String userName;

    /** 下单时间 */
    private Timestamp orderTime;

    /** 订单编号 */
    private String orderBh;

    /** 评价时间 */
    private Timestamp pjTime;

    /** 评价星级 */
    private String pjStar;

    /** 评价标签 */
    private String pjTag;

    /** 评价详情 */
    private String pjDesc;

    /** 上传图片 */
    private String pjPic;
}