/*
*  Copyright 2019-2020 Zheng Jie
*
*  Licensed under the Apache License, Version 2.0 (the "License");
*  you may not use this file except in compliance with the License.
*  You may obtain a copy of the License at
*
*  http://www.apache.org/licenses/LICENSE-2.0
*
*  Unless required by applicable law or agreed to in writing, software
*  distributed under the License is distributed on an "AS IS" BASIS,
*  WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
*  See the License for the specific language governing permissions and
*  limitations under the License.
*/
package me.zhengjie.modules.dm.order.service.dto;

import lombok.Data;
import java.sql.Timestamp;
import java.util.List;
import me.zhengjie.annotation.Query;
import me.zhengjie.modules.dm.order.domain.DmOrderItem;

/**
* @website https://el-admin.vip
* @author sunmz
* @date 2021-09-15
**/
@Data
public class DmOrderRecordQueryCriteria{

    /** 模糊 */
//    @Query(type = Query.Type.INNER_LIKE)
//    private String bh;
    @Query
    private Long id;

    @Query
    private String card;

    @Query(propName = "bh", type = Query.Type.INNER_LIKE, joinName = "orderItem")
    private String bh;
    /** 模糊 */
    @Query(type = Query.Type.INNER_LIKE)
    private String userName;
    /** BETWEEN */
    @Query(type = Query.Type.BETWEEN)
    private List<Timestamp> createDate;

    @Query
    private String money;
}