package me.zhengjie.modules.dm.statement.service;

import me.zhengjie.modules.dm.statement.service.dto.DmEvaluateDto;
import me.zhengjie.modules.dm.statement.service.dto.DmEvaluateQueryCriteria;
import org.springframework.data.domain.Pageable;

import javax.servlet.http.HttpServletResponse;
import java.io.IOException;
import java.text.ParseException;
import java.util.List;
import java.util.Map;

public interface DmEvaluateService {
    /**
     * 查询数据分页
     * @param criteria 条件
     * @param pageable 分页参数
     * @return Map<String,Object>
     */
    Map<String,Object> queryAll(DmEvaluateQueryCriteria criteria, Pageable pageable);

    /**
     * 查询所有数据不分页
     * @param criteria 条件参数
     * @return List<DmServicePjDto>
     */
    List<DmEvaluateDto> queryAll(DmEvaluateQueryCriteria criteria);

    /**
     * 整体评价
     * @param
     * @param stateDate
     * @param pageable
     * @return
     */
    Map<String,Object> selectServicePj (String stateDate, String endDate, String type, Pageable pageable);

    /**
     * 导出数据
     * @param all 待导出的数据
     * @param response /
     * @throws IOException /
     */
    void download(List<DmEvaluateDto> all, HttpServletResponse response) throws IOException;
}
